/* WARNING: automatically generated by gen_disass.py*/


bool is_arm64_ldx_instruction(unsigned int instr) {
  // test if instr is ldxp
  if((instr & 0b10111111111000001000000000000000) == 0b10001000011000000000000000000000) 
    return true;
  // test if instr is ldxr
  if((instr & 0b10111111111000001000000000000000) == 0b10001000010000000000000000000000) 
    return true;
  // test if instr is ldxrb
  if((instr & 0b11111111111000001000000000000000) == 0b00001000010000000000000000000000) 
    return true;
  // test if instr is ldxrh
  if((instr & 0b11111111111000001000000000000000) == 0b01001000010000000000000000000000) 
    return true;
  // test if instr is ldaxp
  if((instr & 0b10111111111000001000000000000000) == 0b10001000011000001000000000000000) 
    return true;
  // test if instr is ldaxr
  if((instr & 0b10111111111000001000000000000000) == 0b10001000010000001000000000000000) 
    return true;
  // test if instr is ldaxrb
  if((instr & 0b11111111111000001000000000000000) == 0b00001000010000001000000000000000) 
    return true;
  // test if instr is ldaxrh
  if((instr & 0b11111111111000001000000000000000) == 0b01001000010000001000000000000000) 
    return true;
  return false;
}

bool is_arm64_stx_instruction(unsigned int instr) {
  // test if instr is stxp
  if((instr & 0b10111111111000001000000000000000) == 0b10001000001000000000000000000000) 
    return true;
  // test if instr is stxr
  if((instr & 0b10111111111000001000000000000000) == 0b10001000000000000000000000000000) 
    return true;
  // test if instr is stxrb
  if((instr & 0b11111111111000001000000000000000) == 0b00001000000000000000000000000000) 
    return true;
  // test if instr is stxrh
  if((instr & 0b11111111111000001000000000000000) == 0b01001000000000000000000000000000) 
    return true;
  // test if instr is stlxp
  if((instr & 0b10111111111000001000000000000000) == 0b10001000001000001000000000000000) 
    return true;
  // test if instr is stlxr
  if((instr & 0b10111111111000001000000000000000) == 0b10001000000000001000000000000000) 
    return true;
  // test if instr is stlxb
  if((instr & 0b11111111111000001000000000000000) == 0b00001000000000001000000000000000) 
    return true;
  // test if instr is stlxrh
  if((instr & 0b11111111111000001000000000000000) == 0b01001000000000001000000000000000) 
    return true;
  return false;
}

unsigned int get_corresponding_arm64_not_exclusive_store(unsigned int store_instr, int* status_register) {
  unsigned int new_instr;

  // test if store_instr is stxp
  if((store_instr & 0b10111111111000001000000000000000) == 0b10001000001000000000000000000000)  {
    // Generating stp instr

    new_instr = 0b00101000100000000000000000000000;

    // Get Rt field
    new_instr |= (store_instr & 0x1f);

    // Get Rn field
    new_instr |= (store_instr & 0x3e0);

    // Get Rt2 field
    new_instr |= (store_instr & 0x7c00);

    // Get size field
    new_instr |= (store_instr & 0x40000000) << 1;

    // Get status register number
    *status_register = ((store_instr & 2031616) >> 16);

    return new_instr;
  }
  // test if store_instr is stxr
  if((store_instr & 0b10111111111000001000000000000000) == 0b10001000000000000000000000000000)  {
    // Generating str instr

    new_instr = 0b10111000000000000000010000000000;

    // Get Rt field
    new_instr |= (store_instr & 0x1f);

    // Get Rn field
    new_instr |= (store_instr & 0x3e0);

    // Get size field
    new_instr |= (store_instr & 0x40000000);

    // Get status register number
    *status_register = ((store_instr & 2031616) >> 16);

    return new_instr;
  }
  // test if store_instr is stxrb
  if((store_instr & 0b11111111111000001000000000000000) == 0b00001000000000000000000000000000)  {
    // Generating strb instr

    new_instr = 0b00111000000000000000010000000000;

    // Get Rt field
    new_instr |= (store_instr & 0x1f);

    // Get Rn field
    new_instr |= (store_instr & 0x3e0);

    // Get status register number
    *status_register = ((store_instr & 2031616) >> 16);

    return new_instr;
  }
  // test if store_instr is stxrh
  if((store_instr & 0b11111111111000001000000000000000) == 0b01001000000000000000000000000000)  {
    // Generating strh instr

    new_instr = 0b01111000000000000000010000000000;

    // Get Rt field
    new_instr |= (store_instr & 0x1f);

    // Get Rn field
    new_instr |= (store_instr & 0x3e0);

    // Get status register number
    *status_register = ((store_instr & 2031616) >> 16);

    return new_instr;
  }
  // test if store_instr is stlxp
  if((store_instr & 0b10111111111000001000000000000000) == 0b10001000001000001000000000000000)  {
    // Generating stp instr

    new_instr = 0b00101000100000000000000000000000;

    // Get Rt field
    new_instr |= (store_instr & 0x1f);

    // Get Rn field
    new_instr |= (store_instr & 0x3e0);

    // Get Rt2 field
    new_instr |= (store_instr & 0x7c00);

    // Get size field
    new_instr |= (store_instr & 0x40000000) << 1;

    // Get status register number
    *status_register = ((store_instr & 2031616) >> 16);

    return new_instr;
  }
  // test if store_instr is stlxr
  if((store_instr & 0b10111111111000001000000000000000) == 0b10001000000000001000000000000000)  {
    // Generating stlr instr

    new_instr = 0b10001000100000001000000000000000;

    // Get Rt field
    new_instr |= (store_instr & 0x1f);

    // Get Rn field
    new_instr |= (store_instr & 0x3e0);

    // Get Rs field
    new_instr |= (store_instr & 0x1f0000);

    // Get Rt2 field
    new_instr |= (store_instr & 0x7c00);

    // Get size field
    new_instr |= (store_instr & 0x40000000);

    // Get status register number
    *status_register = ((store_instr & 2031616) >> 16);

    return new_instr;
  }
  // test if store_instr is stlxb
  if((store_instr & 0b11111111111000001000000000000000) == 0b00001000000000001000000000000000)  {
    // Generating stlrb instr

    new_instr = 0b00001000100000001000000000000000;

    // Get Rt field
    new_instr |= (store_instr & 0x1f);

    // Get Rn field
    new_instr |= (store_instr & 0x3e0);

    // Get Rt2 field
    new_instr |= (store_instr & 0x7c00);

    // Get Rs field
    new_instr |= (store_instr & 0x1f0000);

    // Get status register number
    *status_register = ((store_instr & 2031616) >> 16);

    return new_instr;
  }
  // test if store_instr is stlxrh
  if((store_instr & 0b11111111111000001000000000000000) == 0b01001000000000001000000000000000)  {
    // Generating stlrh instr

    new_instr = 0b01001000100000001000000000000000;

    // Get Rt field
    new_instr |= (store_instr & 0x1f);

    // Get Rn field
    new_instr |= (store_instr & 0x3e0);

    // Get Rt2 field
    new_instr |= (store_instr & 0x7c00);

    // Get Rs field
    new_instr |= (store_instr & 0x1f0000);

    // Get status register number
    *status_register = ((store_instr & 2031616) >> 16);

    return new_instr;
  }
  return 0;
}

